

  /*
        zadatak broj 6
Radeka Natasa  216/00

  napomena: zadatak se poziva na nacin
				       zadatak6 <naziv seminarskog.htm>

                         */


#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>


/*
        Funkcija: VadiNaslov

        parametar - FILE*xml : ulazni tekst stream
        rezultat: alocirani niz struktura Naslov

        int linija - redni broj linije
        int dubina - (f-ja samo dodeljuje ne obradjuje greske)

        char naziv[200] - parsovani naslov

        Enum greska -    0 : ok
                		-1 : naslov nije u tekstu                                                                                                     1 : naslov duzi od 200 karaktera,
                
        char* poruka : 0 ne obradjuje
 */

typedef enum Gr{ Ok, Duzina, Nema = -1 } Greska;

typedef struct Ns{
        int linija;
        int dubina;
        char naziv[200];
        Greska kod_greske;
	char poruka[200];			 /* poruka o gresci*/
} Naslov;

Naslov* VadiNaslov(FILE* xml)
{

        long size = 100;
        long razlika;
        Naslov *naslovi = (Naslov*)calloc(size, sizeof(Naslov))
        , *iter_naslovi = naslovi, *end_naslovi=naslovi+size;
			 /* default na 100 naslova */


        char* buffer = (char*)calloc(1000, sizeof(char));	            /* 1000 karaktera */
        char* iter = buffer;

        unsigned line_counter = 0;

        if(!naslovi)
        {
                perror("Nema dovoljno memorije");
                exit(EXIT_FAILURE);
        }


        if(!buffer)
        {
                perror("Nema dovoljno memorije");
                exit(EXIT_FAILURE);
        }


        /* citanje fajla, obradjuje liniju po liniju, naslov mora
        biti u 1 liniji */
        do{

                fgets(buffer,999,xml);
                iter = buffer;
                ++line_counter;
                while((iter = strstr(iter, "<")) && (*(iter+1)=='H' || *(iter+1)=='h') && isdigit(*(iter+2)) && *(iter+3) == '>')
                {
                        char *kraj_naslova = strstr(iter, "</");

                        if( kraj_naslova && (*(iter+1)=='H' || *(iter+1)=='h') && *(iter+2) == *(kraj_naslova+3) && *(kraj_naslova+4) == '>' )
                        {
                                /* naslov je ok */
                                if(iter_naslovi == end_naslovi)
                                {
                                 naslovi=(Naslov*)realloc(naslovi, size*2);
                                 if(!naslovi)
                                 {
                                        perror("Nema dovoljno memorije");
                                        exit(EXIT_FAILURE);
                                 }
                                 iter_naslovi = naslovi+size;
                                 size*=2;
                                 end_naslovi = naslovi + size;
                                }
                                iter_naslovi->linija=line_counter;
                                iter_naslovi->dubina=*(iter+2)-'0';
                                razlika = kraj_naslova-iter-4;
                                if(razlika > 200)
                                {
                                 iter_naslovi->kod_greske = Duzina;
                                 strncpy(iter_naslovi->naziv, iter+4, 200);
                                 strcpy(iter_naslovi->poruka,"Prevelika duzina");
                                }
                                else
                                {
                                 iter_naslovi->kod_greske = Ok;
                                 strncpy(iter_naslovi->naziv, iter+4, razlika);
                                 strcpy(iter_naslovi->poruka,"");
                                 iter_naslovi++;
                                }

                        }
                        else ; /* ne valja */
                        iter+=2; /* forward "<H" */
                }

        }while( !feof(xml) );

        /* posle ucitavanja sledi parsovanje */
        if(iter_naslovi == end_naslovi)
        {
                naslovi=(Naslov*)realloc(naslovi, size+=sizeof(Naslov));
                if(!naslovi)
                {
                        perror("Nema dovoljno memorije");
                        exit(EXIT_FAILURE);
                }
                iter_naslovi = naslovi+size-1;
        }
        strcpy(iter_naslovi->poruka, "kraj");
        iter_naslovi->dubina = 2;                      /* zbog pravila za zadnji element*/
        free(buffer);
        return naslovi;

}

/*
        Dubina - proverava ispravnost dubine
        i setuje poruku o gresci
 */
void Dubina(Naslov* prethodni, Naslov* naslov)
{
        if(naslov->dubina <2 || naslov->dubina >6)
        {
                strcat(naslov->poruka, " ,Dubina van opsega");
                return;
        }

        if(!strncmp(naslov->naziv, "***", 3) && (naslov+1)->dubina>naslov->dubina)
        {
                strcat(naslov->poruka, " ,Naslov je *** ali dubina nije najveca!");
                return;
        }

        if(prethodni && abs(prethodni->dubina - naslov->dubina)>1)
                strcat(naslov->poruka, " ,Pogresna dubina");
}

/*
        Etiketa - proverava ispravnost etikete
        ispravnost se testira na isalpha
        i setuje poruku o gresci
 */
void Etiketa(Naslov* naslov)
{
        if(*naslov->naziv == '[')
        {
                char *iter = naslov->naziv+1,
                     *iter_end = strchr(iter, ']'); /* Nadji kraj*/
                if(iter_end) /* ako je etiketa */
                  while(iter!=iter_end) /* sve dok nije kraj */
                  {
                        if(!isalpha(*iter++)) /* ako nije alpha */
                        {
                          strcat(naslov->poruka, " ,Karakter koji nije alpha u etiketi!");
                          break;
                        }
                  }
        }
}

/*
        F-ja Analiza:
        parametar - pointer na niz struktura : Naslov
        obradjuje dubinu i prefix,
        takodje poruke o greskama
        i setuje u strukturi
 */

void Analiza(Naslov* naslovi)
{
        Naslov *iter = naslovi, *prethodni = 0;
        while(strcmp(iter->poruka, "kraj")) /* zadnja struktura ima setovano "kraj" */
        {
                /* obrada naslova */

                Dubina(prethodni, iter); /* provera dubine */
                Etiketa(iter); /* provera etikete */

                prethodni = iter++; /* prelazak na sledeci naslov */
        }
}


/*
        Ispis - ispisuje analizirane naslove
 */
void Ispis(Naslov* naslovi)
{
        Naslov* iter = naslovi;
        while(strcmp(iter->poruka, "kraj"))
        {
                /* obrada naslova */
                printf("Red = %04d ", iter->linija);
                switch(iter->dubina)
                {
                 case 6:printf("\t");
                 case 5:printf("\t");
                 case 4:printf("\t");
                 case 3:printf("\t");
                 case 2:printf("\t");
                 default:printf("%d ", iter->dubina);
                }
                printf("%s\n", iter->naziv);
                if(strcmp(iter->poruka, ""))
                 printf("*** %s ***\n", iter->poruka);
                ++iter;
        }
}

/*
        Cistac - dealocira niz prethodno alociranih naslova
 */

void Cistac(Naslov* naslovi)
{
        free(naslovi);
}


int main(int argc, char **argv)
{
        if(argc > 1)
        {
         FILE* f = fopen(argv[1], "r");
         if(f)
         {
                Naslov* n = VadiNaslov(f);
                fclose(f);
                Analiza(n);
                Ispis(n);
                Cistac(n);
         }
         else perror("Greska u otvaranju");
        } else perror("usage: program ime_fajla");

}
